commit 907895c0f247f5667498820939b21db11788f1d4
Author: Christophe Lyon <christophe.lyon@linaro.org>
Date:   Mon Nov 10 10:02:04 2025

    arm: mve: avoid invalid immediate values in vbicq_n, vorrq_n, vmvnq_n [PR122175]
    
    A constant value with the top bit of a 16-bit const passed to vbicq_n_u16 will
    generate invalid assembly.  Avoid this by masking the constant during assembly
    generation.
    
    The same applies to vorrq_n and vmvnq_n.
    
    gcc/ChangeLog:
    
            PR target/122175
            * config/arm/iterators.md (asm_const_size): New mode attr.
            * config/arm/mve.md (@mve_<mve_insn>q_n_<supf><mode>): Use it.
    
    gcc/testsuite/ChangeLog:
    
            PR target/122175
            * gcc.target/arm/mve/intrinsics/pr122175.c: New test.
    
    Co-authored-by: Richard Earnshaw <rearnsha@arm.com>
    (cherry picked from commit 079e570ff8899fefdc3ef3d1a81eaaa6997f5e8e)

diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/pr122175.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/pr122175.c
new file mode 100644
index 00000000000..42873d011a5
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/pr122175.c
@@ -0,0 +1,38 @@
+/* { dg-require-effective-target arm_v8_1m_mve_ok } */
+/* { dg-add-options arm_v8_1m_mve } */
+/* { dg-additional-options "-O2" } */
+
+#include <arm_mve.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+uint16x8_t test_1(uint16x8_t v11) {
+  return vbicq_n_u16(v11, 0x8000);
+}
+
+uint16x8_t test_2(uint16x8_t v11) {
+  return vorrq_n_u16(v11, 0x8000);
+}
+
+uint16x8_t test_3() {
+  return vmvnq_n_u16(0x8000);
+}
+
+mve_pred16_t pred;
+uint16x8_t test_4(uint16x8_t v11) {
+  return vbicq_m_n_u16(v11, 0x8000, pred);
+}
+
+uint16x8_t test_5(uint16x8_t v11) {
+  return vorrq_m_n_u16(v11, 0x8000, pred);
+}
+
+uint16x8_t test_6() {
+  return vmvnq_x_n_u16(0x8000, pred);
+}
+
+#ifdef __cplusplus
+}
+#endif

